/*
 ********************************************************************************
 *            Copyright (c  ) 2015  2015 by esd electronic system design gmbh
 *
 *  This software is copyrighted by and is the sole property of 
 *  esd gmbh.  All rights, title, ownership, or other interests
 *  in the software remain the property of esd gmbh. This
 *  software may only be used in accordance with the corresponding
 *  license agreement.  Any unauthorized use, duplication, transmission,  
 *  distribution, or disclosure of this software is expressly forbidden.
 *
 *  This Copyright notice may not be removed or modified without prior
 *  written consent of esd gmbh.
 *
 *  esd gmbh, reserves the right to modify this software without notice.
 *
 *  electronic system design gmbh          Tel. +49-511-37298-0
 *  Vahrenwalder Str 207                   Fax. +49-511-37298-68 
 *  30165 Hannover                         http://www.esd.eu
 *  Germany                                sales@esd.eu
 *
 ********************************************************************************
 */
#include <common.h>
#include <asm/io.h>
#include <asm/arch-zynq/bootconfig.h>

extern int watchdog_has_fired(void);	/* XXX need proper includes here */
extern u32 zynq_slcr_reboot_status(void);

#define REBOOT_STATUS_REG 0xf8000258
#define REBOOT_STATUS_VALUE_POR 0x00400000
#define REBOOT_STATUS_MASK 0x00400000
#define MULTIBOOT_ADDR_REG 0xf800702c

/*
 *	extract reason for boot from REBOOT status register (set by hardware)
 *	and MULTIBOOT_ADDR register (set by software)
 */
int zynq_get_boot_reason(void)
{
	u32 reboot_status, reboot_status_slcr;
	reboot_status = readl(REBOOT_STATUS_REG) & REBOOT_STATUS_MASK;
	reboot_status_slcr = zynq_slcr_reboot_status(); 
	printf("Reboot_Status 0x%x slcr 0x%x\n", reboot_status, zynq_slcr_reboot_status());
	if (watchdog_has_fired())
		return REBOOT_REASON_CODE_TIMEOUT;
	if (reboot_status_slcr == REBOOT_STATUS_VALUE_POR)
		return REBOOT_REASON_POR;	/* system was powered ON */
/* we cannot use the multiboot register since that is used by the fsbl :(
 *	printf("Read 0x%x from multiboot register\n", readl(MULTIBOOT_ADDR_REG));
 *	reboot_code = (readl(MULTIBOOT_ADDR_REG) >> 16) & 0xffff;
 *	if ((reboot_code & 0xff) != (((reboot_code >> 8) & 0xff) ^ 0xff))
 *		return REBOOT_REASON_CODE_INVALID;
 */
	return REBOOT_REASON_CODE_SRST;	/* more details via EEPROM */
}

