/*
 ********************************************************************************
 *            Copyright (c  ) 2015  2016 by esd electronic system design gmbh
 *
 *  This software is copyrighted by and is the sole property of 
 *  esd gmbh.  All rights, title, ownership, or other interests
 *  in the software remain the property of esd gmbh. This
 *  software may only be used in accordance with the corresponding
 *  license agreement.  Any unauthorized use, duplication, transmission,  
 *  distribution, or disclosure of this software is expressly forbidden.
 *
 *  This Copyright notice may not be removed or modified without prior
 *  written consent of esd gmbh.
 *
 *  esd gmbh, reserves the right to modify this software without notice.
 *
 *  electronic system design gmbh          Tel. +49-511-37298-0
 *  Vahrenwalder Str 207                   Fax. +49-511-37298-68 
 *  30165 Hannover                         http://www.esd.eu
 *  Germany                                sales@esd.eu
 *
 ********************************************************************************
 */
/*
 *	defines and prototypes for reboot reason returned by hardware
 */
#define REBOOT_REASON_POR		1	/* power on reset */
#define REBOOT_REASON_CODE_INVALID	2	/* invalid code in persistent register */
#define REBOOT_REASON_CODE_HRST		3	/* Hard reset e.g. via reset button */
#define REBOOT_REASON_CODE_SRST		4	/* Software initiated reset */
#define REBOOT_REASON_CODE_TIMEOUT	5	/* watchdog initiated reset */

#define DEFAULT_WD_TIMEOUT        300   /* 300 seconds default timeout */
#define DEFAULT_BOOT_OPTION         7   /* default bootoption */

#define EEPROM_OFS_ETHADDR  0       /* ethernet address 6 bytes */
#define EEPROM_OFS_SERNUM   6       /* serial#          8 bytes*/
#define EEPROM_OFS_CHKSUM   14      /* checksum         1 byte */
#define EEPROM_OFS_BOOTOPT  16      /* bootoption       1 byte */

#define GPIO_PIN_EEPROM_WP  13      /* gpio pin 13 connected to EEPROM WP */

/*
 *	extract reason for boot from REBOOT and watchdog status register (set by hardware)
 */
int zynq_get_boot_reason(void);

/* only uses 256 MB since that is the size we got on our final board as well. */
#define RAMDISK_ADDR		0x8000000
#define VXWORKS_ADDR		0xC000000

#ifdef EVAL_BOARD
#define BANK_A_BOOT_OFFSET_STR	"0x100000"	/* start with image right behind U-BOOT */
#define BANK_B_BOOT_OFFSET_STR	"0x880000"
#define BANK_IMAGE_SIZE		0x780000	/* whole space divided by 2 */
#else
#define BANK_A_BOOT_OFFSET_STR	"0x0000000"	/* start with image right behind U-BOOT */
#define BANK_B_BOOT_OFFSET_STR	"0x4000000"
#define BANK_IMAGE_SIZE		0x4000000	/* whole space divided by 2 */
#endif
