/*
 * (C) Copyright 2013 Xilinx, Inc.
 *
 * Configuration settings for the Xilinx Zynq ZC702 and ZC706 boards
 * See zynq-common.h for Zynq common configs
 *
 * SPDX-License-Identifier:	GPL-2.0+
 */

/*
 *	original code from zynq_zc70x.h
 *	modified to fit for philips universal controller board
 */
#ifndef __CONFIG_ZYNQ_UCB7020_H
#define __CONFIG_ZYNQ_UCB7020_H

/* #define CONFIG_ZYNQ_EVALBOARD */
#define CONFIG_SYS_SDRAM_SIZE		(256 * 1024 * 1024) 	/* XXX */

#define CONFIG_ENV_OFFSET        0xE00000

#define CONFIG_ZYNQ_SERIAL_UART0
#define CONFIG_ZYNQ_GEM0
#define CONFIG_ZYNQ_GEM_PHY_ADDR0	7

#define CONFIG_SYS_NO_FLASH

/* Status LED */
#define STATUS_LED_YELLOW           0
#define STATUS_LED_RED              1

#define CONFIG_SYS_I2C_RTC_ADDR 0x68
#define CONFIG_ENV_CALLBACK_LIST_STATIC "bootoption:bootoption"

#define CONFIG_ZYNQ_SDHCI0
#define CONFIG_ZYNQ_QSPI
#define CONFIG_ZYNQ_I2C0
#define CONFIG_ZYNQ_EEPROM
#define CONFIG_ZYNQ_BOOT_FREEBSD

#define CONFIG_POST CONFIG_SYS_POST_MEMORY
#define CONFIG_CRC32_VERIFY
#define CONFIG_PRAM     141312 /* 128 MB for 2 disks + 10MB */
#define CONFIG_CMD_ENV_CALLBACK

/* #define CONFIG_SYS_VXWORKS_BOOT_DEVICE "gem(0,0)host:vxWorks u=target pw=vxTarget f=0x0 tn=xlnx_zynq7k " */
#define CONFIG_SYS_VXWORKS_BOOT_DEVICE "gem(0,0)/ramDrv:0 u=target pw=vxTarget f=0x0 tn=xlnx_zynq7k "
#define CONFIG_SYS_VXWORKS_BOOT_ADDR 0x101100
#define CONFIG_SYS_VXWORKS_MAC_PTR (CONFIG_SYS_VXWORKS_BOOT_ADDR + 0x100)
#define CONFIG_SYS_VXWORKS_BOOTRESULT (CONFIG_SYS_VXWORKS_BOOT_ADDR + 0x110)
#include <configs/zynq-common.h>

#undef CONFIG_SF_DEFAULT_SPEED
#define CONFIG_SF_DEFAULT_SPEED    40000000

/* we have to undef server ip to be able to automatically set it on dhcp */
#undef CONFIG_BOOTP_SERVERIP
#undef CONFIG_BOOTDELAY
#define CONFIG_BOOTDELAY 1
#undef CONFIG_SERVERIP
#undef CONFIG_IPADDR
/* #define CONFIG_SERVERIP 10.0.0.190 */

#undef CONFIG_EXTRA_ENV_SETTINGS
#define CONFIG_EXTRA_ENV_SETTINGS       \
        "bitstream_image=system.bit.bin\0"      \
        "boot_image=BOOT.bin\0" \
        "image_addr=0x8000000\0"       \
        "image_crc32_addr=0xBFFFFFC\0"       \
        "reserved_mem_addr=0xC000000\0"       \
        "reserved_mem_crc32_addr=0xFFFFFFC\0"       \
        "bootoption=1\0" \
        "wd_timeout=300\0" \
        "loadbootenv_addr=0x2000000\0" \
        "kernel_size=0x500000\0"        \
        "boot_size=0xF00000\0"  \
        "fdt_high=0x20000000\0" \
        "initrd_high=0x20000000\0"      \
        "bootenv=uEnv.txt\0" \
	"image_len=4000000\0" \
	"image_len_wo_crc=3FFFFFC\0" \
	"image_name=generator/bankImage.ima\0" \
	"vxWorks_load_addr=1000000\0" \
	"stop_boot=led yellow off; led red on\0" \
	"load_and_run_vx=if crc32 -v ${image_addr} ${image_len_wo_crc} ${image_crc32_addr}; " \
			"then fatload ram 0:0 ${vxWorks_load_addr} vxWorks.elf && " \
            "run wd && " \
			"bootvx $vxWorks_load_addr; " \
		"fi\0" \
	"tftp_prog_boot=tftpboot ${image_addr} ${image_name} && " \
		"if crc32 -v ${image_addr} ${image_len_wo_crc} ${image_crc32_addr}; then " \
			"sf probe 1 && " \
			"sf update $image_addr $pri_bank $image_len && " \
			"sf read $image_addr $pri_bank $image_len && " \
			"run load_and_run_vx; " \
		"else echo Image ${image_name} has invalid checksum; " \
		"fi; \0" \
	"normal_boot=sf probe 1 && " \
		"sf read $image_addr $pri_bank $image_len && " \
		"bootres P && " \
		"if run load_and_run_vx; " \
		"then echo boot from $pri_bank; " \
		"else " \
			"bootres PT && " \
			"run tftp_prog_boot; " \
		"fi\0" \
	"boot_on_probation=if test $bootstatus -eq 4; " \
		"then sf probe 1 && " \
			"sf read $image_addr $sec_bank $image_len && " \
			"bootres P && " \
			"run load_and_run_vx; " \
		"fi; "\
		"bootres S && " \
        "env set wd true && " \
		"sf probe 1 && " \
		"sf read $image_addr $pri_bank $image_len && " \
		"run load_and_run_vx\0" \
	"fetch_and_boot=if test $bootstatus -eq 4; " \
		"then if crc32 -v ${reserved_mem_addr} ${image_len_wo_crc} ${reserved_mem_crc32_addr}; " \
			"then echo Image detected! programming to $sec_bank && " \
				"sf probe 1 && " \
				"sf update ${reserved_mem_addr} $sec_bank $image_len && " \
				"sf read $image_addr $sec_bank $image_len && " \
				"bootres P && " \
				"run load_and_run_vx; " \
			"else echo NO IMAGE DETECTED! && " \
				"sf probe 1 && " \
				"sf read $image_addr $pri_bank $image_len && " \
				"bootres SF && " \
				"run load_and_run_vx; " \
			"fi; " \
		"else sf probe 1 && " \
            "env set wd true && " \
			"sf read $image_addr $pri_bank $image_len && " \
			"bootres S && " \
			"run load_and_run_vx; " \
		"fi;\0" \
	"boot_method2=bootres P && " \
		"if test ${bootstatus} -eq 4; " \
		"then run tftp_prog_boot; bootres PF; " \
		"else && bootres SF; " \
		"fi; " \
	    "sf probe 1 && " \
		"sf read ${image_addr} ${sec_bank} ${image_len} && " \
		"env set wd true && " \
		"run load_and_run_vx;\0" \
	"new_boot=printenv bootoption bootstatus && " \
        "i2c mw 68 10 a5 1; " \
        "env set wd true; " \
		"if test ${bootoption} -le 2; " \
		"then run normal_boot; " \
		"else " \
            "env set wd watchdog; " \
            "if test ${bootoption} -le 4; " \
			"then run fetch_and_boot; " \
			"else if test ${bootoption} -le 6; " \
				"then run boot_on_probation; " \
				"else run boot_method2; " \
				"fi; " \
			"fi; " \
		"fi; " \
		"run stop_boot\0" \
	"serial_debug_Image=loadb ${image_addr} && " \
        "fatload ram 0:0 ${vxWorks_load_addr} vxWorks.elf && " \
		"bootvx ${vxWorks_load_addr}; run stop_boot\0" \
	"debug_Image=tftpboot ${image_addr} ${image_name} && " \
        "fatload ram 0:0 ${vxWorks_load_addr} vxWorks.elf && " \
		"bootvx ${vxWorks_load_addr}; run stop_boot\0"


#endif /* __CONFIG_ZYNQ_UCB7020_H */
